// Határozzunk meg minden olyan helyet, ahol a maximumérték található!

#include <iostream>
#include <fstream>

using namespace std;

int const maxDim = 101;

ifstream fin("adatok.in");

void beOlvas(int & n, int x[]){

	fin >> n; 
	for(int i = 1; i <= n; i++)
		fin >> x[i];	
}

void kiir(int n, int x[]){

	cout << "n = " << n << endl;
	for(int i = 1; i <= n; i++)
		cout << x[i] << " ";	
	cout << endl;
}

void maximumokHelye(int n, int x[], int poz[], int & db){
// iteratív implementáció

	int max = x[1];			// inicializálás: maximumérték
	db = 1;					// a poz tömb hossza
	poz[1] = 1;				// a poz tömb első eleme
	for(int i = 2; i <= n; i++){
		if(max < x[i]){
			max = x[i];
			db = 1;
			poz[db] = i;
        } 
        else{
        	if(max == x[i]){
            	db++;
				poz[db] = i;
          	}
        }
    }
}

void maximumokHelyeRek(int n, int x[], int poz[], int & db, int max){
// rekurzív implementáció
	
    if(n >= 1){
      	if(max < x[n]){
        	poz[1] = n;
        	db = 1;
        	maximumokHelyeRek(n - 1, x, poz, db, x[n]);
      	}
      	else{
        	if(max == x[n]){
        		db++;
          		poz[db] = n;
          		maximumokHelyeRek(n - 1, x, poz, db, max);
        	} 
        	else
          		maximumokHelyeRek(n - 1, x, poz, db, max);
        }
    }
}


int main(){
	int n, db;
	int x[maxDim], poz[maxDim];
	
	beOlvas(n, x);
	kiir(n, x);

	cout << "Iterativan: " << endl;
	maximumokHelye(n, x, poz, db);
	cout << "A tomb maximuma elofordul a kovetkezo helyeken:" << endl;
	kiir(db, poz);	

	cout << "Rekurzivan: " << endl;
	db = 0;
	maximumokHelyeRek(n, x, poz, db, x[n]);
	cout << "A tomb maximuma elofordul a kovetkezo helyeken:" << endl;
	kiir(db, poz);	
}

