/* 
Adott az n elemű (3 ≤ n ≤ 10 000), egész számokat tároló x sorozat, ahol az elemek értéke nagyobb, mint -30 000 és 
kisebb, mint 30 000. 
Írjatok alprogramot, amely meghatároz három számot az x sorozatból, amelyeknek a szorzata maximális. 
Az alprogram bemeneti paraméterei n és x, kimeneti paraméterei az a, b és c számok, amelyek az x sorozat elemei és 
rendelkeznek a kért tulajdonsággal. Ha a feladatnak több megoldása van, csak egyet kell megadnotok.
*/

#include <fstream>
#include <iostream>

using namespace std;

const int maxDim = 10001;
const int Legkisebb = -30000;	// lehetséges legkisebb érték
const int Legnagyobb = 30000;	// lehetséges legnagyobb érték


ifstream f("szorzat3.in");

void beOlvas(int & n, int a[]){
// a sorozat beolvasása

	f >> n;
	for(int i = 1; i <= n; i++)
		f >> a[i];	
}

void kiIr(int n, int a[]){
// kiírjuk a beolvasott sorozatot

	cout << "n = " << n << endl;
	for(int i = 1; i <= n; i++)
		cout << a[i] << " ";
	cout << endl;
}

void naivAlgoritmus(int n, int x[], int & a, int & b, int & c){
// meghatározzuk a maximális szorzat szorzótényezõit - ellenõrzés céljából 

float maxSzorzat = float(Legkisebb) * Legkisebb * Legkisebb;
int szorzat;

	for(int i = 1; i < n - 1; i++)
		for(int j = i+1; j <= n-1; j++)
			for(int k = j+1; k <= n; k++){
				szorzat = x[i] * x[j] * x[k];
				if(szorzat > maxSzorzat){// veszély: nem biztos, hogy a szorzat ábrázolható (szorzat6.in)
					maxSzorzat = szorzat;
					a = x[i];
					b = x[j];
					c = x[k];
				}
			}
}

int const MAX = 600003;		// a lineáris rendezéshez szükséges segédsorozat elemeinek darabszáma
int aux[MAX];				// a lineáris rendezéshez szükséges segédsorozat 
const int PLUSZ = 30001;	// szükségünk lesz erre az értékre az indexek kiszámításához

void linearisRendezes(int n, int x[], int & a, int & b, int & c){
// ládarendezéssel rendezzük az x sorozatot

	for(int i = 1; i <= MAX; i++)
		aux[i] = 0;

	for(int j = 1; j <= n; j++)
		aux[x[j] + PLUSZ]++;

	int q = 0;

	for(int i = 1; i <= MAX; i++){
		for(int j = 1; j <= aux[i]; j++){
			q++;
			x[q] = i - PLUSZ;
		}
	}
}

void buborekRendezes(int n, int a[]){
// rendezzük buborekrendezéssel az a sorozatot

	bool rendezett;

	while (!rendezett){
		rendezett = true;
		for (int i = 1; i < n; i++){
			if (a[i] > a[i + 1]){
				int aux = a[i];
				a[i] = a[i + 1];
				a[i + 1] = aux;
				rendezett = false;
			}	
		}
	}
}
	
void maxSzorzat(int n, int x[], int &a, int &b, int &c){
// kiválasztjuk a 3 számot az első kettőből és az utolsó háromból

	int min1 = x[1];
	int min2 = x[2];
	int max1 = x[n];
	int max2 = x[n - 1];
	int max3 = x[n - 2];

	if((max1 > 0) && (min1 * min2 > max2 * max3)){
		a = max1;
		b = min1;
		c = min2;
	}
	else{
		a = max1;
		b = max2;
		c = max3;		
	}
}

// OPTIMÁLIS megoldás O(n)

int minim(int n, int x[], int lim){
// az x sorozat minimuma, de "vigyázunk", hogy ne használjuk kétszer az eddigi legkisebb (lim) értéket

	int min = -Legkisebb;//30000
	for (int i = 1; i <= n; i++)
		if ((x[i] < min) && (x[i] > lim))
			min = x[i];
	return min;
}

int maxim(int n, int x[], int lim){
// az x sorozat maximuma, de "vigyázunk", hogy ne használjuk kétszer az eddigi legnagyobb (lim) értéket

	int max = -Legnagyobb;
	for (int i = 1; i <= n; i++)
		if ((x[i] > max) && (x[i] < lim))
			max = x[i];
	return max;
}

void maxSzorzatOpt(int n, int x[], int & a, int & b, int & c){
// meghatározzuk a két legkisebb és a három legnagyobb értéket
 
	// Kezdőértékek:
	int min1 = -Legkisebb;				// a sorozat legkisebb eleme
	int min2 = -Legkisebb;				// a második legkisebb elem
	int max1 = -Legnagyobb;				// a sorozat legnagyobb eleme
	int max2 = -Legnagyobb;				// a második legnagyobb elem
	int max3 = -Legnagyobb;				// a harmadik legnagyobb elem

	// a két legkisebb és a három legnagyobb elem meghatározása
	min1 = minim(n, x, Legkisebb);	
	min2 = minim(n, x, min1);		
	max1 = maxim(n, x, Legnagyobb);	
	max2 = maxim(n, x, max1);		
	max3 = maxim(n, x, max2);		

	if((max1 > 0) && (min1 * min2 > max2 * max3)){
		a = max1;
		b = min1;
		c = min2;
	}
	else{
		a = max1;
		b = max2;
		c = max3;		
	}
}

void kiirEredmeny(int a, int b, int c){
	cout << "Maximalis szorzat (kizarolag ellenorzes celjabol) = " << a * b * c << endl;
	cout << "a = " << a << " b = " << b << " c = " << c << endl;
}

void masol(int n, int x[], int y[]){
// masolat az x sorozatról

	for(int i = 1; i <= n; i++)
		y[i] = x[i];
}

int main(){	

int n, x[maxDim], y[maxDim], z[maxDim];
int a, b, c;

	beOlvas(n, x);
	kiIr(n, x);
	masol(n, x, y);
	masol(n, x, z);
	
	naivAlgoritmus(n, x, a, b, c);	// naiv algoritmus O(n^3)
	cout << endl << "A naiv algoritmus (ellenorzes celjabol): " << endl;
	kiirEredmeny(a, b, c);
	
	cout << endl << "Eredmeny linearis rendezessel: " << endl;
	linearisRendezes(n, x, a, b, c);	// linearis rendezes: O(n)
	maxSzorzat(n, x, a, b, c);	
	kiirEredmeny(a, b, c);
	
	cout << endl << "Eredmeny buborekrendezessel: " << endl;
	buborekRendezes(n, y);		// négyzetes rendezés O(n^2)
	maxSzorzat(n, y, a, b, c);	
	kiirEredmeny(a, b, c);

	cout << endl << "Linearis algoritmussal: " << endl;// 5 * O(n) + O(1) = O(n)
	maxSzorzatOpt(n, z, a, b, c);
	kiirEredmeny(a, b, c);	
}
