#include <fstream>
#include <iostream>
#include <string>

using namespace std;

ifstream fin("balraAt_8.in");

void beOlvas(int & n, string & gy){

	fin >> n;
	fin >> gy;
}

void kiIr(int & n, string gy){

	cout << "n = " << n << endl;
	cout << "Gyermekek: ";
	cout << gy << endl;
}

// O(n^2)-es megoldas segedsorozattal
int balraAt_1(int n, string gy){
	
	bool fordult;
	int idoEgyseg = 0;
	string masolat = gy;

	do{
		fordult = false;
		for(int i = 1; i <= n - 1; i++){
			if(masolat[i] == 'j' && masolat[i + 1] == 'b'){ // elkerüljük, hogy egy gyerek többször is megforduljon
				gy[i] = 'b';
				gy[i + 1] = 'j';
				fordult = true;
			}
		}
		masolat = gy;
		if(fordult)
			idoEgyseg++;
	}while(fordult);

	return idoEgyseg;
}

// O(n^2)-es megoldas segedsorozat nélkül
int balraAt_2(int n, string gy){
// a gy sorozat másolata nélkül

	bool fordult;
	int idoEgyseg = 0;

	do{
		int i = 1; 
		fordult = false;
		while(i <= n){	
			if ((gy[i] == 'j') && (gy[i + 1] == 'b')){
				gy[i] = 'b';
				gy[i + 1] = 'j';
				i = i + 2;
				fordult = true;
			}
			else
				i++;
		}
		if(fordult)
			idoEgyseg++;
	}while(fordult);

	return idoEgyseg;
}

// O(n) 
int balraAt_3(int n, string gy){

int idoEgyseg = 0;
int ido = 0;
int lepes = 0;

  	for(int i = 1; i <= n; i++){
    	if(gy[i] == 'j'){
           	ido++;
           	if(lepes > 0) 
             	lepes--;
        } 
    	if(gy[i] == 'b'){ 
    		if(ido > 0){
           		idoEgyseg = ido + lepes;
    		   	lepes++;
           	}
        }
    }

    return idoEgyseg;
}

int main(){
	int n;
	string gy;
	
	beOlvas(n, gy);
	kiIr(n, gy);

	cout << "Eltelt " << balraAt_1(n, gy) << " idoegyseg." << endl;
	cout << "Eltelt " << balraAt_2(n, gy) << " idoegyseg." << endl;
	cout << "Eltelt " << balraAt_3(n, gy) << " idoegyseg." << endl;

	return 0;
}